import { URL } from 'url';
import { request as httpReq } from 'http';
import { request as httpsReq } from 'https';
const defaultOptions = {
    method: 'GET',
    maxRedirects: 3,
    headers: {}
};
export const tall = (url, options) => {
    const opt = Object.assign({}, defaultOptions, options);
    return new Promise((resolve, reject) => {
        try {
            const { protocol, host } = new URL(url);
            let [, port] = host.split(':', 2);
            if (typeof port === 'undefined') {
                // if no port is specified set the port based on protocol
                port = protocol === 'https:' ? '443' : '80';
            }
            const method = opt.method;
            const request = protocol === 'https:' ? httpsReq : httpReq;
            const headers = opt.headers;
            return request(url, { method, headers }, response => {
                if (response.headers.location && opt.maxRedirects) {
                    opt.maxRedirects--;
                    return resolve(tall(response.headers.location.startsWith('http')
                        ? response.headers.location
                        : `${protocol}//${host}${response.headers.location}`, opt));
                }
                resolve(url);
            })
                .on('error', reject)
                .end();
        }
        catch (err) {
            return reject(err);
        }
    });
};
//# sourceMappingURL=index.js.map